/*
 * Routines within this files are Copyright Colten Edwards 1996
 * Aka panasync on irc.
 * Thanks to Shiek and Flier for helpful hints and suggestions. As well 
 * as code in some cases.
 */
 
#include "irc.h"

#include <sys/stat.h>

#ifdef ESIX
# include <lan/net_types.h>
#endif

#ifdef HAVE_UNAME
#include <sys/utsname.h>
#endif

#include "parse.h"
#include "ircterm.h"
#include "server.h"
#include "chelp.h"
#include "edit.h"
#include "crypt.h"
#include "vars.h"
#include "ircaux.h"
#include "lastlog.h"
#include "window.h"
#include "screen.h"
#include "whois.h"
#include "hook.h"
#include "input.h"
#include "ignore.h"
#include "keys.h"
#include "names.h"
#include "alias.h"
#include "history.h"
#include "funny.h"
#include "ctcp.h"
#include "dcc.h"
#include "translat.h"
#include "output.h"
#include "exec.h"
#include "notify.h"
#include "numbers.h"
#include "status.h"
#include "if.h"
#include "help.h"
#include "stack.h"
#include "queue.h"
#include "timer.h"
#include "list.h"
#include "pluto.h"
#include "misc.h"
#include "userlist.h"
#include "whowas.h"
#include "window.h"

time_t in_sping = 0;

void nwhois (char *command, char *args, char *subargs)
{
ChannelList *tmp;
NickList *user = NULL;
int once = 0;
char *nick;
int mem_use = 0, max_mem = 0;
	if (args && *args)
	{
		tmp = server_list[from_server].chan_list;
		if (!tmp)
		{
			bitchsay("No Channel");
			return;
		}
		nick = next_arg(args, &args);
		while (tmp)
		{
			for (user = tmp->nicks; user; user = user->next)
			{
				if (match(user->nick, nick) || match(nick, user->nick))
				{
					if (!once)
					{
put_it("Channel    @ v  UL: l   a  p  SL: l      +o   -o   +b   -b  kicks  nicks   pub");
						once++;
					}
put_it("%-10s %c %c    %3d  %2d %2d     %2d    %4d %4d %4d %4d  %5d  %5d %5d",
tmp->channel, user->chanop? '@':' ',user->voice?'v':' ',user->userlist?user->userlist->level:0, 
user->userlist?user->userlist->aop:0,user->userlist?user->userlist->prot:0, user->shitlist?user->shitlist->level: 0,
user->stat_ops,user->stat_dops, user->stat_bans, user->stat_unbans, 
user->stat_kicks, user->stat_nicks, user->stat_pub);
					mem_use = sizeof(NickList) + (user->userlist? sizeof(UserList): 0) + (user->shitlist? sizeof(ShitList):0) + (user->botlist?sizeof(UserList):0);
					if (max_mem < mem_use)
						max_mem = mem_use;
					break;
				}
			}				
			tmp = tmp->next;
		}
		if (once)
			bitchsay("End /NWhoIs list for %s [Mem Usage: %d bytes per chan]", nick, max_mem);
		else
			bitchsay("No such nick %s on any channel", nick);
	}
	else
		userage("NWhois", "<nick>");
}

void whowas _((char *command, char *args, char *subargs))
{
	if (!command)
		show_whowas();
	else
		show_wholeft(NULL);
}

void do_sk _((char *command, char *args, char *subargs))
{
char *serv = NULL;
char *to = NULL;
int count;
NickList *Nick;
ChannelList *chan;
int server = 0;

	if (!args || !*args)
	{
		userage("Sk", "<server> [channel]");
		return;
	}
	serv = next_arg(args, &args);
	if (*serv == '#')
	{
		bitchsay("You need to specify a server not a channel");
	}
	to = next_arg(args, &args);
	if (!(chan = prepare_command(&server, to, NEED_OP)))
		return;
		
	bitchsay("Performing Lame Server kicks on %s", chan->channel);
	for (Nick = chan->nicks, count = 0; Nick; Nick = Nick->next)
	{
		if (Nick->server && match(serv, Nick->server))
		{
			if (!isme(Nick->nick))
			{
				send_to_server("KICK %s %s : Lame Server Kick", chan->channel, Nick->nick);
				count++;
			}
		}
	}
	if (count)
		bitchsay("Found %d lamerz on %s from %s", count, to, serv);
}

int check_args(char *remote_host, char *remote_ip)
{
struct hostent *host;

	host = gethostbyname(remote_host);

	if (host == NULL) 
	{
		unsigned char a,b,c,d,n;
		unsigned char addr[5];
		/* hmm.. perhaps it was a dotted quad entered.. */
		n = sscanf(remote_host,"%u.%u.%u.%u",&a,&b,&c,&d);
		if (n != 4) 
		{
			bitchsay("error: host '%s' not found",remote_host);
			return 0;
		}
		addr[0] = a;
		addr[1] = b;
		addr[2] = c;
		addr[3] = d;
		host = gethostbyaddr(addr,4,AF_INET);
		if (host == NULL) {
			bitchsay("error: host '%s' not found",remote_host);
			return 0;
		}
		sprintf(remote_ip,"%u.%u.%u.%u",a,b,c,d);
	} 
	else 
	{
		sprintf(remote_ip,"%u.%u.%u.%u", (unsigned char) host->h_addr_list[0][0],
			(unsigned char) host->h_addr_list[0][1],
			(unsigned char) host->h_addr_list[0][2],
			(unsigned char) host->h_addr_list[0][3]);
	}
	return 1;
}

int scan(char *remote_host, char *remote_ip, int low_port, int high_port)
{
	int soc;
	struct sockaddr_in addr;
	struct servent *serv;
	int port,rc,addr_len,opt;
	int found = 0;

	for (port = low_port;port <= high_port;port++) 
	{
		soc = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);

		if (soc < 0) 
		{
			bitchsay("error: socket() failed");
			return(0);
		}

		rc = setsockopt(soc,SOL_SOCKET,SO_REUSEADDR,&opt,sizeof(opt));

		addr.sin_family = AF_INET;
		addr.sin_addr.s_addr = inet_addr(remote_ip);
		addr.sin_port = htons(port);

		addr_len = sizeof(addr);
		alarm(1);
		rc = connect(soc, (struct sockaddr*) &addr, addr_len);
		alarm(0);
		close(soc);

		if (rc >= 0)
		{
			serv = getservbyport(htons(port),"tcp");
			found++;
			put_it("port %d (%s) is running",port,(serv == NULL)?"UNKNOWN": serv->s_name);
		}
	}
	if (!found)
		bitchsay("Wonder what hostname that was. No ports found");
	return 1;
}

void findports(char *command, char *args, char *subargs)
{
char *remote_host;
char remote_ip[20];
int low_port = 6660;
int high_port = 7000;
	if (args && *args)
	{
		char *tmp = NULL;
		remote_host = next_arg(args, &args);
		if (args && *args)
		{
			tmp = next_arg(args, &args);
			low_port = strtoul(tmp, NULL, 10);	
			if (args && *args)
			{
				tmp = next_arg(args, &args);
				high_port = strtoul(tmp, NULL, 10);	
			}
			else
				high_port = low_port;
		}
		if (check_args(remote_host, remote_ip))
		{
			bitchsay("Scanning %s's tcp ports %d through %d",remote_host, low_port,high_port);
			scan(remote_host, remote_ip, low_port, high_port);
		}
	} else
		userage("Fports", "<hostname> [lowport] [high port]");
	return;
}

void add_ban_word(char *command, char *args, char *subargs)
{
char *word = NULL;
char *chan = NULL;
WordKickList *new;

	if (args && *args)
	{
		chan = next_arg(args, &args);
		if (!is_channel(chan) || !args || !*args)
		{
			userage(command ? command : "BanWords", "<channel\002|\002*> <word(s)>");
			return;
		}
		if (!command)
		{
			new = (WordKickList *)find_in_list((List **)&ban_words, args, 0);
			if (!ban_words || !new || (new && !match(new->channel, chan)))
			{
				new = (WordKickList *) new_malloc(sizeof(WordKickList));
				malloc_strcpy(&new->channel, chan);
				malloc_strcpy(&new->string, args);
				add_to_list((List **)&ban_words, (List *)new);
				bitchsay("Added %s to %s Banned Word List", new->string, new->channel);
			} else bitchsay("[%s] is already in the list for channel %s", args, chan);
		}
		else
		{
			malloc_strcpy(&word, args);
			if ((new = (WordKickList *) remove_from_list((List **)&ban_words, word)))
			{
				bitchsay("Removed %s Banned Word [%s]", new->channel, new->string);
				new_free(&new->channel);
				new_free(&new->string);
				new_free((char **)&new);
			} else 
				bitchsay("Banned Word %s not found.", word);
			new_free(&word);
		}
	} else
		userage(command ? command : "BanWords", "<channel\002|\002*> <word(s)>");
}

void show_word_kick (char *command, char *args, char *subargs)
{
WordKickList *new;
	if (ban_words) 
	{
		put_it("%14s %40s", "Channel", "Banned Word(s)");
		for (new = ban_words; new; new = new->next)
			put_it("%-14s %40s", new->channel, new->string);
	} else
		bitchsay("No Banned Words on list");
}

void save_banwords(FILE *outfile)
{
	int count = 0;
	WordKickList *new;
	if (ban_words)
	{
		fprintf(outfile, "# %s Banned Words\n", version);
		for (new = ban_words; new; new = new->next)
		{
			fprintf(outfile, "BANWORD %s %s\n", new->channel, new->string);
			count++;
		}
	}
	if (do_hook(SAVEFILE_LIST,"BanWords %d", count))
		bitchsay("Saved %d Banned Words List", count);
}

void whereis (char *command, char *args, char *subargs)
{
NickList *tmp = NULL;
WhowasList *tmp1;
ChannelList *chan;
char *nick;
	if (args && *args)
	{
		nick = next_arg(args, &args);
		for (chan = server_list[from_server].chan_list; chan; chan = chan->next)
			if ((tmp = (NickList *)find_in_list((List **)&chan->nicks, nick, 0)))
				break;
		if (!tmp)
		{
			tmp1 = find_in_whowas(nick);
			if (tmp1) tmp = tmp1->nicklist;
		}
		if (tmp && tmp->server)
		{
			char *p = NULL, *user = NULL;
			malloc_strcpy(&user, tmp->host);
			p = strchr(user, '@');
			*p++ = '\0';
			send_to_server("PRIVMSG %s@%s :%cVERSION%c",user, tmp->server,CTCP_DELIM_CHAR,CTCP_DELIM_CHAR);
			new_free(&user);
		}
		else bitchsay("No such user [%s].", nick);
	} else userage("Whereis", "<nick>");
}

char *recreate_saymode(ChannelList *chan)
{
static char mode_str[] = "iklmnpsta";
static char buffer[BIG_BUFFER_SIZE+1];
int mode_pos = 0;
int mode;
char *s;
        buffer[0] = '\0';
        s = buffer;
        mode = chan->modelock_val;
	while (mode)
	{
		if (mode % 2)
			*s++ = mode_str[mode_pos];
		mode /= 2;
		mode_pos++;
	}
	if (chan->key && *chan->key)
	{
		*s++ = ' ';
		strcpy(s, chan->key);
		s += strlen(chan->key);
	}
	if (chan->limit)
		sprintf(s, " %d", chan->limit);
	else
		*s = '\0';
	return buffer;
}

int check_mode_lock(char *channel, char *mode_list, int server)
{
ChannelList *chan;
char buffer[BIG_BUFFER_SIZE+1];

	if ((chan = lookup_channel(channel, server, 0)) && chan->modelock_key)
	{
		char *newmode;
		char *modelock = NULL;
		char *new_mode_list = NULL;
		char *save, *save1;
		char *args = NULL, *args1 = NULL;
		int add = 0;
		memset(buffer, 0, sizeof(buffer));

		malloc_strcpy(&modelock, chan->modelock_key);
		malloc_strcpy(&new_mode_list, mode_list);
		save1 = new_mode_list;
		save = modelock;
		new_mode_list = next_arg(new_mode_list, &args1);
		modelock = next_arg(modelock, &args);		

		while (*modelock)
		{
			newmode = strchr(mode_list, *modelock);
			switch(*modelock)
			{
				case '+':
					add = 1;
					break;
				case '-':
					add = 0;
					break;
				case 'k':
					if (newmode)
					{
						if (add)
						{
							char *key;
							key = next_arg(args1, &args1);
							if (chan->key)
							{
								strcat(buffer, "-k " );
								strcat(buffer, chan->key);
							}
							key = next_arg(args, &args);
							if (key)
							{
								strcat(buffer, " +k ");
								strcat(buffer, key);
								strcat(buffer, " ");
							}
						}
						else
						{
							if (!chan->key)
								break;
							strcat(buffer, "-k ");
							strcat(buffer, chan->key);
						}
						strcat(buffer, " ");
					}
					break;
				case 'l':
					if (newmode)
					{
						if (add)
						{
							int limit = 0;
							if (args && *args)
								limit = strtoul(args, &args, 10);
							if (limit > 0)
							{
								strcat(buffer, "+l ");
								strcat(buffer, ltoa(limit));
								strcat(buffer, " ");
							}
						}
						else
						{
							chan->limit = 0;
							strcat(buffer, "-l");
						}
					}
					break;
				default:
					if (newmode)
					{
						if (add)
						{
							strcat(buffer, "+");
						}
						else
						{
							strcat(buffer, "-");
						}
						buffer[strlen(buffer)] = *modelock;
						strcat(buffer, " ");
					}
					break;
			}
			modelock++;
		}
		if (chan && chan->chop && buffer)
			send_to_server("MODE %s %s", chan->channel, buffer);
		new_free(&save);
		new_free(&save1);
		return 1;
	}
	return 0;
}

void mode_lock _((char *command, char *args, char *subargs))
{
ChannelList *chan;
int i = 0;
char *channel = NULL;
u_long mode = 0;
int value = 0;

char *t = NULL;
char *key = NULL;

	if (command && *command && !strcmp(command, "ModeLock"))
	{
		if (!args || !*args)
		{
			userage(command, "[channel] <+/-><instampkl #>");
			return;
		}
		t = next_arg(args, &args);
		if (is_channel(t))
		{
			channel = t;		
			t = next_arg(args, &args);
		} else
			channel = get_channel_by_refnum(0);
		if (!t || !*t)
		{
			bitchsay("No Mode Specified");
			return;
		}
		if ((chan = lookup_channel(channel, from_server, 0)))
		{
			char valid_mode[BIG_BUFFER_SIZE + 1];
			char *buffer = NULL;
			int limit = -1;
			int add = 0;
			memset(valid_mode, 0, sizeof(valid_mode));
			while (*t && i < BIG_BUFFER_SIZE)
			{
				switch(*t)
				{
					case '+':
						add = 1;
						valid_mode[i++] = '+';
						break;
					case '-':
						add = 0;
						valid_mode[i++] = '-';
						break;
					case 'm':
						value = MODE_MODERATED;
						valid_mode[i++] = *t;
						break;
					case 'a':
						value = MODE_ANON;
						valid_mode[i++] = *t;
						break;
					case 'i':
						value = MODE_INVITE;
						valid_mode[i++] = *t;
						break;
					case 'n':
						value = MODE_MSGS;
						valid_mode[i++] = *t;
						break;
					case 's':
						value = MODE_SECRET;
						valid_mode[i++] = *t;
						break;
					case 't':
						value = MODE_TOPIC;
						valid_mode[i++] = *t;
						break;
					case 'p':
						value = MODE_PRIVATE;
						valid_mode[i++] = *t;
						break;
					case 'k':
						value = MODE_KEY;
						valid_mode[i++] = *t;
						if (add)
							key = next_arg(args, &args);
						else
							key = NULL;
						break;
						
					case 'l':
						valid_mode[i++] = *t;
						value = MODE_LIMIT;
						if (add)
							if (args && *args)
								limit = strtoul(args, &args, 10);
						else
							limit = 0;
						break;
					default:
						break;
				}
				if (add)
					mode |= value;
				else
					mode &= ~value;
		
				t++;
			}
			chan->modelock_val = mode;
			malloc_strcpy(&buffer, valid_mode);
			if (key && *key)
			{
				malloc_strcat(&buffer, " ");
				malloc_strcat(&buffer, key);
			}
			if (limit > 0)
			{
				malloc_strcat(&buffer, " ");
				malloc_strcat(&buffer, ltoa(limit));
			}
			if (*buffer)
			{
				malloc_strcpy(&chan->modelock_key, buffer);
				bitchsay("%s Mode Locked at: [%s] %s", chan->channel, buffer, (chan->limit > 0) ? "Users":"");
			} else
				bitchsay("Invalid Mode for [%s]", chan->channel);
		} else
			bitchsay("No Such Channel");
	}
	else if (command && *command && !my_stricmp(command, "ClearLock"))
	{

		if (!args || !*args)
		{
			userage(command, "[channel|*]");
			return;
		}
		t = next_arg(args, &args);
		if (t && *t && *t != '*')
		{
			if ((chan = lookup_channel(t, from_server, 0)))
			{
				new_free(&chan->modelock_key);
				chan->modelock_val = 0;
				bitchsay("Cleared %s Mode Lock", chan->channel);
			} else
				bitchsay("No such Channel [%s]", t);
		} 
		else if (t && *t && *t == '*')
		{
			for (chan = server_list[from_server].chan_list; chan; chan = chan->next)
			{
				new_free(&chan->modelock_key);
				chan->modelock_val = 0;
			}
			bitchsay("Cleared All Channel Mode Locks");
		} else
			userage(command, "[channel|*]");
	}
	else
	{
		for (i = 0; i < number_of_servers; i++ )
		{
			for (chan = server_list[i].chan_list; chan; chan = chan->next)
				bitchsay("Lock on %s: %s", chan->channel, chan->modelock_key ? chan->modelock_key : "none");
		}
	}
}

void randomnick _((char *command, char *args, char *subargs))
{
char *prefix = NULL, *p;
int count = 1;
int len = 0;
	while ((p = next_arg(args, &args)))
	{
		if (isdigit(*p))
			count = atol(p);
		else
			prefix = p;
	}
	if (prefix && (len = strlen(prefix)))
	{
		if (len > 5)
			*(prefix + 6) = 0;
	}
	while (count > 0)
	{
		send_to_server("NICK %s%s", prefix?prefix:"", random_str(3,9-len));
		count--;
	}
}

void topic_lock _((char *command, char *args, char *subargs))
{
ChannelList *chan;
char *t, *channel;
	if (!args || !*args)
	{
		userage(command, "<#channel> [on\002|\002off]");
		return;
	}
	t = next_arg(args, &args);
	if (args && *args)
	{
		channel = t;
		if (!is_channel(channel))
			return;
		t = next_arg(args, &args);
	} else 
		channel = get_channel_by_refnum(0);
		
	if ((chan = lookup_channel(channel, from_server, 0)))
	{
		if (t && *t && !my_stricmp(t, "ON"))
		{
			chan->topic_lock = 1;
		}
		else if (t && *t && !my_strnicmp(t, "OF", 2))
			chan->topic_lock = 0;
		else
			userage(command, "<#channel> [on\002|\002off]");
		bitchsay("Topic lock for [%s] - %s", chan->channel, on_off(chan->topic_lock));
	}
}

void sping (char *command, char *args, char *subargs)
{
	char *servern = next_arg(args, &args);
	if (servern && *servern && match("*.*", servern))
	{
		bitchsay("Sent PING to server [\002%s\002]", servern);
		if (!my_stricmp(servern, get_server_name(from_server)))
			send_to_server("PING %lu %s", time(NULL), servern);
		else
		{
			in_sping = time(NULL);
			send_to_server("PING %s %s", get_server_itsname(from_server), servern);
		}
	}
	else
		userage(command, "[servername]");
}

void tog_fprot(char *command, char *args, char *subargs)
{
static int here = 0;
	if (args && *args)
	{
		if (!my_stricmp(args, "ON"))
			here = 0;
		else if (!my_stricmp(args, "OFF"))
			here = 1;
		else
		{
			userage(command, "On|Off");
			return;
		}
	}		

	if (here)
	{
		set_int_var(CTCP_FLOOD_PROTECTION_VAR, 0);
		set_int_var(FLOOD_PROTECTION_VAR, 0);
		here = 0;
	} else
	{
		set_int_var(CTCP_FLOOD_PROTECTION_VAR, 1);
		set_int_var(FLOOD_PROTECTION_VAR, 1);
		here = 1;
	}
	bitchsay("Toggled flood protection - [%s]", on_off(here));
}

void do_toggle (char *command, char *args, char *subargs)
{
if (!args || !*args)
{

put_it("%s", convert_output_format("%G---%g%G-%K[ %WBitchX %wToggles %K]-%g%G-%g---%K%g--%K%g-%K--- --  - --- -- -", NULL));
put_it("%s", convert_output_format("%G   %Cauto_ns%clookup %K[%W$[-3]0%K]    %Cctcp_f%clood_protection %K[%W$[-3]1%K]    %Cbeep%c        %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(AUTO_NSLOOKUP_VAR)), on_off(get_int_var(CTCP_FLOOD_PROTECTION_VAR)), on_off(get_int_var(BEEP_VAR))));
put_it("%s", convert_output_format("%G   %Cpub%cflood      %K[%W$[-3]0%K]    %Cflood_p%crotection      %K[%W$[-3]1%K]    %Ckickf%clood   %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(PUBFLOOD_VAR)), on_off(get_int_var(FLOOD_PROTECTION_VAR)), on_off(get_int_var(KICKFLOOD_VAR))));
put_it("%s", convert_output_format("%g   %Cdcc%c_autoget   %K[%W$[-3]0%K]    %Cflood_k%cick            %K[%W$[-3]1%K]    %Cmsg%clog      %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(DCC_AUTOGET_VAR)), on_off(get_int_var(FLOOD_KICK_VAR)), on_off(get_int_var(MSGLOG_VAR))));
put_it("%s", convert_output_format("%G   %Cll%cook         %K[%W$[-3]0%K]    %Cdeop%cflood             %K[%W$[-3]1%K]    %Cjoin%cflood   %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(LLOOK_VAR)), on_off(get_int_var(DEOPFLOOD_VAR)), on_off(get_int_var(JOINFLOOD_VAR))));
put_it("%s", convert_output_format("%g|   %Cauto_w%chowas   %K[%W$[-3]0%K]    %Cverb%cose_ctcp          %K[%W$[-3]1%K]    %Cnickfl%cood   %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(AUTO_WHOWAS_VAR)), on_off(get_int_var(VERBOSE_CTCP_VAR)), on_off(get_int_var(NICKFLOOD_VAR))));
put_it("%s", convert_output_format("%G:   %Ccl%coak         %K[%W$[-3]0%K]    %Coper%cview              %K[%W$[-3]1%K]    %Cshit%clist    %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(CLOAK_VAR)), on_off(get_int_var(OV_VAR)), on_off(get_int_var(SHITLIST_VAR))));
put_it("%s", convert_output_format("%G:   %Ckick_o%cps      %K[%W$[-3]0%K]    %Cannoy%c_kick            %K[%W$[-3]1%K]    %Cuser%clist    %K[%W$[-3]2%K]", "%s %s %s", on_off(get_int_var(KICK_OPS_VAR)), on_off(get_int_var(ANNOY_KICK_VAR)), on_off(get_int_var(USERLIST_VAR))));
put_it("%s", convert_output_format("%K|   %Chack%cing       %K[%W$[-3]0%K]    %Cnick_c%completion       %K[%W$[-3]1%K]    %Cauto_r%cejoin %K[%W$[-3]2%K]","%s %s %s", on_off(get_int_var(HACKING_VAR)),on_off(get_int_var(NICK_COMPLETION_VAR)), on_off((get_int_var(AUTO_REJOIN_VAR)?1:0)) ));
put_it("%s", convert_output_format("%g:   %Cdisp%clay_ansi  %K[%W$[-3]0%K]    %Wtype /toggle <setting>         %Clog         %K[%W$[-3]1%K]", "%s %s", on_off((get_int_var(AUTO_REJOIN_VAR)?1:0)),on_off((get_int_var(LOG_VAR)?1:0)) ));
} 
else
{
	if (!my_strnicmp(args, "auto_nslookup", 7))
	{
		set_int_var(AUTO_NSLOOKUP_VAR, (get_int_var(AUTO_NSLOOKUP_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GAuto-NSlookup %K[%W$[-3]0%K]","%s", on_off(get_int_var(AUTO_NSLOOKUP_VAR)) ));
	} else if (!my_strnicmp(args, "pubflood", 3))
	{
		set_int_var(PUBFLOOD_VAR, (get_int_var(PUBFLOOD_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GPub Flood %K[%W$[-3]0%K]","%s", on_off(get_int_var(PUBFLOOD_VAR))));
	} else if (!my_strnicmp(args, "dcc_autoget", 3))
	{
		set_int_var(DCC_AUTOGET_VAR, (get_int_var(DCC_AUTOGET_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GDCC Auto Get %K[%W$[-3]0%K]","%s", on_off(get_int_var(DCC_AUTOGET_VAR))));
	} else if (!my_strnicmp(args, "llook", 2))
	{
		set_int_var(LLOOK_VAR, (get_int_var(LLOOK_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GLink Look %K[%W$[-3]0%K]","%s", on_off(get_int_var(LLOOK_VAR))));
	} else if (!my_strnicmp(args, "auto_whowas", 6))
	{
		set_int_var(AUTO_WHOWAS_VAR, (get_int_var(AUTO_WHOWAS_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GAuto-WhoWas %K[%W$[-3]0%K]","%s", on_off(get_int_var(AUTO_WHOWAS_VAR))));
	} else if (!my_strnicmp(args, "cloak", 2))
	{
		set_int_var(CLOAK_VAR, (get_int_var(CLOAK_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GCloaking %K[%W$[-3]0%K]","%s", on_off(get_int_var(CLOAK_VAR))));
	} else if (!my_strnicmp(args, "kick_ops", 6))
	{
		set_int_var(KICK_OPS_VAR, (get_int_var(KICK_OPS_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GKick Ops %K[%W$[-3]0%K]","%s", on_off(get_int_var(KICK_OPS_VAR))));
	} else if (!my_strnicmp(args, "ctcp_flood_protection", 6))
	{
		set_int_var(CTCP_FLOOD_PROTECTION_VAR, (get_int_var(CTCP_FLOOD_PROTECTION_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GCtcp Flood Protection %K[%W$[-3]0%K]","%s", on_off(get_int_var(CTCP_FLOOD_PROTECTION_VAR))));
	} else if (!my_strnicmp(args, "flood_protection",7))
	{
		set_int_var(FLOOD_PROTECTION_VAR, (get_int_var(FLOOD_PROTECTION_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GFlood Protection %K[%W$[-3]0%K]","%s", on_off(get_int_var(FLOOD_PROTECTION_VAR))));
	} else if (!my_strnicmp(args, "flood_kick", 7))
	{
		set_int_var(FLOOD_KICK_VAR, (get_int_var(FLOOD_KICK_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GFlood Kicks %K[%W$[-3]0%K]","%s", on_off(get_int_var(FLOOD_KICK_VAR))));
	} else if (!my_strnicmp(args, "deopflood",4))
	{
		set_int_var(DEOPFLOOD_VAR, (get_int_var(DEOPFLOOD_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GDeOp Flood %K[%W$[-3]0%K]","%s", on_off(get_int_var(DEOPFLOOD_VAR))));
	} else if (!my_strnicmp(args, "verbose_ctcp",4))
	{
		set_int_var(VERBOSE_CTCP_VAR, (get_int_var(VERBOSE_CTCP_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GVerbose CTCP %K[%W$[-3]0%K]","%s", on_off(get_int_var(VERBOSE_CTCP_VAR))));
	} else if (!my_strnicmp(args, "operview", 4))
	{
		set_int_var(OV_VAR, (get_int_var(OV_VAR)));
		put_it("%s", convert_output_format("%cToggled %GOver View %K[%W$[-3]0%K]","%s", on_off(get_int_var(OV_VAR))));
	} else if (!my_strnicmp(args, "annoy_kick",4))
	{
		set_int_var(ANNOY_KICK_VAR, (get_int_var(ANNOY_KICK_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GAnnoy Kicks %K[%W$[-3]0%K]","%s", on_off(get_int_var(ANNOY_KICK_VAR))));
	} else if (!my_strnicmp(args, "beep",4))
	{
		set_int_var(BEEP_VAR, (get_int_var(BEEP_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GBeep %K[%W$[-3]0%K]","%s", on_off(get_int_var(BEEP_VAR))));

	} else if (!my_strnicmp(args, "kickflood",5))
	{
		set_int_var(KICKFLOOD_VAR, (get_int_var(KICKFLOOD_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GKick Flood %K[%W$[-3]0%K]","%s", on_off(get_int_var(KICKFLOOD_VAR))));
	} else if (!my_strnicmp(args, "msglog", 3))
	{
		set_int_var(MSGLOG_VAR, (get_int_var(MSGLOG_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GMSG log %K[%W$[-3]0%K]","%s", on_off(get_int_var(MSGLOG_VAR))));
	} else if (!my_strnicmp(args, "joinflood", 4))
	{
		set_int_var(JOINFLOOD_VAR, (get_int_var(JOINFLOOD_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GJoin Flood %K[%W$[-3]0%K]","%s", on_off(get_int_var(JOINFLOOD_VAR))));
	} else if (!my_strnicmp(args, "nickflood", 6))
	{
		set_int_var(NICKFLOOD_VAR, (get_int_var(NICKFLOOD_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GNick Flood %K[%W$[-3]0%K]","%s", on_off(get_int_var(NICKFLOOD_VAR))));
	} else if (!my_strnicmp(args, "shitlist", 4))
	{
		set_int_var(SHITLIST_VAR, (get_int_var(SHITLIST_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GShitList %K[%W$[-3]0%K]","%s", on_off(get_int_var(SHITLIST_VAR))));
	} else if (!my_strnicmp(args, "userlist", 4))
	{
		set_int_var(USERLIST_VAR, (get_int_var(USERLIST_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GUserList %K[%W$[-3]0%K]","%s", on_off(get_int_var(USERLIST_VAR))));
	} else if (!my_strnicmp(args, "hacking", 4))
	{
		set_int_var(HACKING_VAR, (get_int_var(HACKING_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GHacking %K[%W$[-3]0%K]","%s", on_off(get_int_var(HACKING_VAR))));
	} else if (!my_strnicmp(args, "auto_rejoin", 6))
	{
		set_int_var(AUTO_REJOIN_VAR, (get_int_var(AUTO_REJOIN_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GAuto_Rejoin %K[%W$[-3]0%K]","%s", on_off(get_int_var(AUTO_REJOIN_VAR))));
	} else if (!my_strnicmp(args, "nick_completion", 6))
	{
		set_int_var(NICK_COMPLETION_VAR, (get_int_var(NICK_COMPLETION_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GNick Completion %K[%W$[-3]0%K]","%s", on_off(get_int_var(NICK_COMPLETION_VAR))));
	} else if (!my_strnicmp(args, "display_ansi", 4))
	{
		set_int_var(DISPLAY_ANSI_VAR, (get_int_var(DISPLAY_ANSI_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GAnsi Display %K[%W$[-3]0%K]","%s", on_off(get_int_var(DISPLAY_ANSI_VAR))));
	} else if (!my_strnicmp(args, "log", 3))
	{
		int old_window_display = window_display;
		set_int_var(LOG_VAR, (get_int_var(LOG_VAR)?0:1));
		put_it("%s", convert_output_format("%cToggled %GLogging %K[%W$[-3]0%K]","%s", on_off(get_int_var(LOG_VAR))));
		window_display = 0;
		logger(get_int_var(LOG_VAR));
		window_display = old_window_display;
	} else
		put_it("   Unknown /toggle [%s]", args);
}

}


static char *com_arg = NULL;
static char *reason = NULL;
int in_who_kill = 0;
static char *tcom_arg = NULL;
static char *treason = NULL;
int in_trace_kill = 0;

void who_handlekill(char *nick, char *user, char *host)
{
static int count = 0;
	if (!nick)
	{
		if (count == 0)
		{
			bitchsay("No Match for kill of [%s]", com_arg);
		}
		new_free(&reason);
		new_free(&com_arg);
		in_who_kill = 0;   
		count = 0;
		return;
        }
	if (!my_stricmp(nick, get_server_nickname(from_server)))
		return;
	bitchsay("Killing %s!%s@%s[%s] %d", nick, user, host, com_arg, ++count);
	if (!reason)
		malloc_strcpy(&reason, get_reason(nick));
	send_to_server("KILL %s :%s (%d)", nick, reason, count);
}

void show_version (char *command, char *args, char *subargs)
{
char *nick;
char *version_buf = NULL;
#ifdef HAVE_UNAME
struct utsname buf;
	uname(&buf);
	malloc_strcpy(&version_buf, stripansicodes(convert_output_format(get_string_var(FORMAT_VERSION_VAR), "%s %s %s %s", irc_version, internal_version, buf.sysname, buf.release?buf.release:"")));
#else
	malloc_strcpy(&version_buf, stripansicodes(convert_output_format(get_string_var(FORMAT_VERSION_VAR), "%s %s %s %s", irc_version, internal_version, "unknown", "")));
#endif
	if (args && *args)
		nick = next_arg(args, &args);
	else
		nick = get_channel_by_refnum(0);
	send_text(nick, version_buf, "PRIVMSG", 1);
	new_free(&version_buf);
}

#ifdef __STDC__
void whokill (char *command, char *args, char *subargs)
#else
void whokill(command, args)
char *command;
char *args;
char *subargs;
#endif
{
	char *pattern;
	
	if (com_arg && in_who_kill)
	{
		bitchsay("Already doing %s", command);
		return;
	}
        if (!(pattern=next_arg(args, &args)))
	{
		userage(command, "<pattern> [reason]");
		return;
	}

	if (args && *args)
		malloc_strcpy(&reason, args); 
	else
		new_free(&reason);
		
	if (*pattern != '*')
		malloc_strcpy(&com_arg, "*");
	malloc_strcat(&com_arg, pattern);
	if ((*(com_arg+strlen(com_arg)-1) != '*') || (strlen(com_arg) == 1))
		malloc_strcat(&com_arg, "*");
	send_to_server("WHO %s", com_arg);
	in_who_kill = 1;
}

void trace_handlekill(char *nick)
{
static int count = 0;
	if (!nick)
	{
		if (count == 0 && in_trace_kill != 2)
		{
			bitchsay("No Match for trace kill of [%s]", tcom_arg);
		}
		new_free(&treason);
		new_free(&tcom_arg);
		in_trace_kill = 0;   
		count = 0;
		return;
        }
	if (!my_stricmp(nick, get_server_nickname(from_server)))
		return;
	bitchsay("Killing %s[%s] %d", nick, tcom_arg, ++count);
	if (!treason)
		malloc_strcpy(&treason, get_reason(nick));
	send_to_server("KILL %s :%s (%d)", nick, treason, count);
}

#ifdef __STDC__
void handle_tracekill(char *nick, char *user, char *host)
#else
void handle_tracekill(nick, user, host)
char *nick;
char *user;
char *host;
#endif
{
	char temp[20];
	if (!nick)
	{
		trace_handlekill(NULL);
		return;
	}
	if (match(tcom_arg, nick))
	{
		if (in_trace_kill == 2)
			bitchsay("User: %s", nick);
		else
		{
			strncpy(temp, nick, 15);
			temp[15] = '\0';
			if (!strrchr(temp, '['))
				return;
			*strrchr(temp, '[') = '\0';
			if (!my_stricmp(temp, get_server_nickname(from_server)))
				return;
			trace_handlekill(temp);
		}
	}
}

#ifdef __STDC__
void tracekill(char *command, char *args, char *subargs)
#else
void tracekill(command, args, subargs)
char *command;
char *args;
char *subargs;
#endif
{
	char *pattern;

	if (in_trace_kill)
	{
		bitchsay("Already in %s", command);
		return;
	}
	if (!(pattern = next_arg(args, &args)))
	{
		userage(command, "<pattern> [reason]");
		return;
	}
	if (args && *args)
		malloc_strcpy(&treason, args);
	else
		new_free(&treason);

        if (*pattern != '*')
	{
                malloc_strcpy(&tcom_arg, "*");
	        malloc_strcat(&tcom_arg, pattern);
	} else malloc_strcpy(&tcom_arg, pattern);
        if ((*(tcom_arg+strlen(tcom_arg)-1) != '*') || (strlen(tcom_arg) == 1))
                malloc_strcat(&tcom_arg, "*");

	if (treason && *treason == '-')
		in_trace_kill = 2;
	else
		in_trace_kill = 1;
	send_to_server("TRACE");
}

#ifdef __STDC__
void traceserv(char *command, char *args, char *subargs)
#else
void traceserv(command, args, subargs)
char *command;
char *args;
char *subargs;
#endif
{
	char *server, *pattern;

	if (in_trace_kill)
	{
		bitchsay("Already in %s", command);
		return;
	}
	if (!(server = next_arg(args, &args)) ||
		!(pattern = next_arg(args, &args)))
	{
		userage(command, "<server> <pattern> [reason]");
		return;
	}
	if (args && *args)
	        malloc_strcpy(&treason, args);
	else
		new_free(&treason);
        if (*pattern != '*')
	{
                malloc_strcpy(&tcom_arg, "*");
	        malloc_strcat(&tcom_arg, pattern);
	} else malloc_strcpy(&tcom_arg, pattern);
        if ((*(tcom_arg+strlen(tcom_arg)-1) != '*') || (strlen(tcom_arg) == 1))
                malloc_strcat(&tcom_arg, "*");

	if (treason && *treason == '-') 
		in_trace_kill = 2;
	else
		in_trace_kill = 1;
        send_to_server("TRACE %s", server);
}

#if 0
#FTP shell for irc
#by R0M
#v1.0a
^assign ftp_pgm ncftp

alias ftp {
 ^window new name FTP level crap lastlog all
 ^exec -window -name FTP $ftp_pgm $0- 
  hmo
 ^query %FTP
 ^on ^exec_exit FTP {hmf;window show ncftp kill}
 }

alias hmo ^set hold_mode on
alias hmf ^set hold_mode off
echo Welcome to ftp v1.0a by R0M
echo to connect simply type /ftp <site>
echo to find out which dir you are in simply type pwd
echo have fun :)
#endif

void ftp ( char *command, char *args, char *subargs)
{
Window *window, *tmp;
char name[40];
char *pgm = NULL;

	sprintf(name, "%%%s", command);
	if (!my_stricmp(command, "ftp"))
		pgm = get_string_var(FTP_VAR);
	else if (!my_stricmp(command, "shell"))
		pgm = get_string_var(SHELL_VAR);
	else
		pgm = command;
		
	if (!args || !*args)
	{
		if (!is_window_name_unique(name+1))
		{
			int logic = -1;
			if ((tmp = get_window_by_name(name+1)))
			{
				delete_window(tmp);
				if ((logic = logical_to_index(name+1)) > -1)
					kill_process(logic, 15);
				else bitchsay("No such process [%s]", name+1);
			}
			update_all_windows();
			return;
		}
	}
	if ((tmp = new_window()))
	{
		int refnum;
		char *p = NULL;
		window = tmp;
		if (is_window_name_unique(name+1))
		{
			malloc_strcpy(&window->name, name+1);
			window->update |= UPDATE_STATUS;
		}

		hide_window(window);
		set_current_window(window);
		window->window_level = LOG_NONE;
		revamp_window_levels(window);
		window->lastlog_level = LOG_NONE;
		bits_to_lastlog_level(window->lastlog_level);
		refnum = window->refnum;
		
		update_all_windows();
		malloc_sprintf(&p, "%s %s", pgm, args);
		start_process(p, name+1, NULL, NULL, refnum);
		if (is_process(name))
		{
			NickList *tmp_nick = NULL;
			malloc_strcpy(&window->query_nick, name);
			tmp_nick = (NickList *)new_malloc(sizeof(NickList *));
			malloc_strcpy(&tmp_nick->nick, name);
			add_to_list((List **)&window->nicks, (List *)tmp_nick);
		}
		new_free(&p);
	} else bitchsay("Unable to create a new window");	
}

void botlink (char *command, char *args, char *subargs)
{
	return;
}

void jnw (char *command, char *args, char *subargs)
{
char *channel;
	channel = next_arg(args, &args);
	if (channel && is_channel(channel))
	{
		Window *tmp;
		if ((tmp = new_window()))
		{
			int     server;
			server = from_server;
			from_server = tmp->server;
			send_to_server("JOIN %s", channel);
			malloc_strcpy(&tmp->waiting_channel, channel);
			from_server = server;
			update_all_windows();
		}
	} else
		userage(command, "<#channel>");
}
