/* 
 *  Copyright Colten Edwards (c) 1996
 */
#include <stdio.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <unistd.h>
#if defined(sparc) && defined(sun4c)
#include <sys/rusage.h>
#endif


#include "irc.h"
#include "server.h"
#include "edit.h"
#include "crypt.h"
#include "vars.h"
#include "ircaux.h"
#include "lastlog.h"
#include "window.h"
#include "screen.h"
#include "whois.h"
#include "hook.h"
#include "input.h"
#include "ignore.h"
#include "keys.h"
#include "names.h"
#include "alias.h"
#include "history.h"
#include "funny.h"
#include "ctcp.h"
#include "dcc.h"
#include "translat.h"
#include "output.h"
#include "exec.h"
#include "notify.h"
#include "numbers.h"
#include "status.h"
#include "list.h"
#include "timer.h"
#include "pluto.h"
#include "userlist.h"
#include "bot.h"
#include "misc.h"
#include "flood.h"
#include "whowas.h"

extern char *invite_channel;
extern int user_count;
extern int shit_count;
extern int bot_count;
extern time_t start_time;
extern int in_server_ping;

extern char *last_sent_notice;
extern char *last_sent_msg;

ChannelList default_statchan = { 0 };
ChannelList *idlechan_list = NULL;
NickTab *tabkey_array = NULL, *autoreply_array = NULL;
CloneList *clones = NULL;

#define getrandom(min, max) ((rand() % (int)(((max)+1) - (min))) + (min))


char *awaymsg = NULL;

char *convert_time(time_t ltime)
{
	time_t  days = 0,hours = 0,minutes = 0,seconds = 0;
	static char buffer[100];
	*buffer = '\0';
	seconds = ltime % 60;
	ltime = (ltime - seconds) / 60;
	minutes = ltime%60;
	ltime = (ltime - minutes) / 60;
	hours = ltime % 24;
	days = (ltime - hours) / 24;
	sprintf(buffer, "%2ldd %2ldh %2ldm %2lds", days, hours, minutes, seconds);
	return(*buffer ? buffer : "");
}

void do_uptime( char *command, char *args, char *subargs)
{
#ifdef WANT_ANSI
put_it("%s",convert_output_format("%G[ %WBitchX%g%wClient%g%RStatistics %G]---%g--%K-%g--%G--%K-%g--- %K--%g  -",NULL));
put_it("%s",convert_output_format("%G| %CClient Version: %W$0 $1","%s %s", irc_version, internal_version));
put_it("%s",convert_output_format("%G %CClient Running Since %W$0-","%s",my_ctime(start_time)));
put_it("%s",convert_output_format("%G| %CClient Uptime: %W$0-","%s",convert_time(time(NULL)-start_time)));
put_it("%s",convert_output_format("%G %CCurrent UserName: %W$0-","%s", username));
put_it("%s",convert_output_format("%G: %CCurrent RealName: %W$0-","%s", realname));
put_it("%s",convert_output_format("%G. %CLast Message: %W$0-","%s",last_msg[0].last_msg?last_msg[0].last_msg:"None"));
put_it("%s",convert_output_format("%G: %CLast Notice: %W$0-","%s",last_notice[0].last_msg?last_notice[0].last_msg:"None"));
put_it("%s",convert_output_format("%G. %CLast Sent Msg: %W$0-","%s",last_sent_msg?last_sent_msg:"None"));
put_it("%s",convert_output_format("%G: %CLast Sent Notice: %W$0-","%s",last_sent_notice?last_sent_notice:"None"));
put_it("%s",convert_output_format("%G %CLast Channel invited to: %R$0-","%s",invite_channel?invite_channel:"None"));
put_it("%s",convert_output_format("%G| %cTotal Users on Userlist: %K[%R$0%K]","%d",user_count));
put_it("%s",convert_output_format("%G %cTotal Users on Shitlist: %K[%R$0%K]","%d",shit_count));
put_it("%s",convert_output_format("%G| %cTotal Bots on Botlist:   %K[%R$0%K]","%d",bot_count));
#else
int old_ansi = strip_ansi_in_echo;
	strip_ansi_in_echo = 0;

	say("--------------------- \002%s Client Statistics\002 --------------------", version);
	say("\002Client Version\002: %s", irc_version);
	say("\002Client Running\002 since %s ", my_ctime(start_time));
	say("\002Client Uptime\002: %s.", convert_time(time(NULL)-start_time));
	say("\002Current Username\002: %s", username);
	say("\002Current realname\002: %s", realname);
	say("\002Last Message\002: %s", last_msg[0].last? last_msg[0].last: "\002None\002");
	say("\002Last Notice\002: %s", last_notice?last_notice:"\002None\002");
	say("\002Last Channel invited\002 to %s", invite_channel? invite_channel:"\002None\002");
	say("\002Total Users\002 on Userlist: %d", user_count);
	say("\002Total Users\002 on shitlist: %d", shit_count);
	say("\002Total Botz \002 on Botlist:  %d", bot_count);
	strip_ansi_in_echo = old_ansi;
#endif
}

/* extern_write -- controls whether others may write to our terminal or not. */
/* This is basically stolen from bsd -- so its under the bsd copyright */
#ifdef __STDC__
void extern_write (char *command, char *args, char *subargs)
#else
void	extern_write (command, args, subargs)
char *command, *arg, *subargs;
#endif
{
	char *tty;
	struct stat sbuf;
	const int OTHER_WRITE = 020;
	int on = 0;
	  
	if (!(tty = ttyname(2)))
	{
		yell("Internal error: notify %s", "edwac@sasknet.sk.ca");
		yell("Error in ttyname()");
		return;
	}
	if (stat(tty, &sbuf) < 0)
	{
		yell("Internal error: notify %s", "edwac@sasknet.sk.ca");
		yell("Error in stat()");
		return;
	}
	if (!args || !*args)
	{
		if (sbuf.st_mode & 020)
			bitchsay("Mesg is \002On\002");
		else
			bitchsay("Mesg is \002Off\002");
		return;
	}
	if (!my_stricmp(args, "ON") || !my_stricmp(args, "YES"))
		on = 1;
	else if (!my_stricmp(args, "OFF") || !my_stricmp(args, "NO"))
		on = 0;
	else
	{
		userage("Mesg","<Yes\002|\002No\002|\002On\002|\002Off>");
		return;
	}		
	switch (on)
	{
		case 1 :
			if (chmod(tty, sbuf.st_mode | OTHER_WRITE) < 0)
			{
				yell("Sorry, couldnt set your tty's mode");
				return;
			}
			bitchsay("Mesg is \002On\002");
			break;
		case 0 :
			if (chmod(tty, sbuf.st_mode &~ OTHER_WRITE) < 0)
			{
				yell("Sorry, couldnt set your tty's mode");
				return;
			}
			bitchsay("Mesg is \002Off\002");
			break;
	}
	
}


int check_serverlag _((void *args))
{
	char *servern = (char *)args;
	if (servern && *servern)
	{
		int i = 0;
		for (i = 0; i < server_list_size(); i++)
		{
			if (is_server_connected(i) && (!my_stricmp(servern, get_server_itsname(i)) || !my_stricmp(servern, get_server_name(i))))
			{
				server_list[i].lag_time = time(NULL);
				send_to_server("PING %lu %s", server_list[i].lag_time, servern);
				in_server_ping++;
				break;
			}
		}
	}
	return 0;
}

int timer_unban _((void *args))
{
	char *p = (char *)args;
	char *channel;
	char *nick;

	channel = next_arg(p, &p);
	nick = next_arg(p, &p);
	send_to_server("MODE %s -b %s", channel, nick);
	new_free(&channel);
	return 0;
}

int timer_idlekick _((void *args))
{
char *channel = (char *)args;
ChannelList *tmp;
int kick_count = 0;
UserList *user = NULL, *bot = NULL;

	if ((tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK)) && are_you_opped(channel) && tmp->max_idle && tmp->check_idle)
	{
		NickList *nick;
		for (nick = tmp->nicks; nick; nick = nick->next)
		{
			user = nick->userlist;
			if (user && check_channel_match(user->channels, channel))
				continue;			
			if ((bot = nick->botlist) && check_channel_match(user->channels, channel)) 
				continue;
			if (!my_stricmp(nick->nick, get_server_nickname(from_server)))
				continue;
			if ((nick->chanop || nick->voice) && !get_int_var(KICK_OPS_VAR))
				continue;
			if (time(NULL) - nick->idle_time >= tmp->max_idle)
			{
				if (kick_count <= get_int_var(MAX_IDLEKICKS_VAR))
				{
					char *p = NULL;
					malloc_sprintf(&p, "%s %s*!*%s", channel, nick->nick, nick->host);
					send_to_server("MODE %s +b %s*!*%s", channel, nick->nick, nick->host);
					send_to_server("KICK %s %s :\002%s\002: (Idle Channel User)", channel, nick->nick, version);
					add_timer(-1, 60, timer_unban, p, NULL);
				}
				else
					break;
				kick_count++;
			}
		}
	}		
	if (tmp && tmp->max_idle && tmp->check_idle)
		add_timer(-1, get_int_var(IDLE_CHECK_VAR), timer_idlekick, channel, NULL);
	else
		new_free(&channel);

	return 0;
}

void addidle (char *command, char *args, char *subargs )
{
time_t default_idle = 10 * 60;
char *channel = NULL, *p;
time_t seconds = 0;
ChannelList *tmp, *new = NULL;

	if (args && *args)
	{
		p = next_arg(args, &args);
		if (*p == '#')
			malloc_sprintf(&channel, "%s", p);
		else
			malloc_sprintf(&channel, "#%s", p); 
		if (args && *args)
			seconds = atol(args);

		if (seconds < default_idle)
			seconds = default_idle;

		if (!(new = (ChannelList *)find_in_list((List **)&idlechan_list, channel, 0)))
		{
			new = (ChannelList *)new_malloc(sizeof(ChannelList));
			memcpy(new, &default_statchan, sizeof(ChannelList));
			malloc_strcpy(&new->channel, channel);
			add_to_list((List **)&idlechan_list, (List *)new);
		} 
		new->max_idle = seconds;
		new->check_idle = (my_strnicmp(command, "UN", 2) == 0) ? 0: 1;

		if (!new->check_idle)
		{
			new_free(&channel);
		} 
		else
		{
			if ((tmp = lookup_channel(channel, from_server, CHAN_NOUNLINK)))
			{
				if (new && new->check_idle)
				{
					tmp->max_idle = new->max_idle;
					tmp->check_idle = new->check_idle;
					add_timer(-1, get_int_var(IDLE_CHECK_VAR), timer_idlekick, channel, NULL);
					bitchsay("Idle checking turned %s for %s %d mins",tmp->check_idle? "On":"Off", channel, tmp->max_idle/60); 
				} 
			} else
				new_free(&channel);
		}
	} else
		userage(command ? "UnIdle":"AddIdle", my_stricmp(command,"AddIdle") ? "<channel>" : "<channel> [seconds -default 10min]");
}

void showidle (char *command, char *args, char *subargs )
{
ChannelList *tmp;
char *channel = NULL;
int count = 0;
NickList *nick;
time_t ltime;
int server;

	if (args && *args)
		channel = next_arg(args, &args);
	if (!(tmp = prepare_command(&server, channel, NO_OP)))
		return;


	for (nick = tmp->nicks; nick; nick = nick->next)
	{
		if (!count && do_hook(SHOWIDLE_HEADER_LIST, "%s %d", tmp->channel, tmp->max_idle))
			bitchsay("Idle check for %s Max Idle Time [ %s ]", channel,convert_time(tmp->max_idle) );
		ltime = time(NULL) - nick->idle_time;
		if (do_hook(SHOWIDLE_LIST, "%s %s %d %d", nick->nick, nick->host, find_user_level(nick->nick, nick->host, tmp->channel), ltime))
			put_it("%-20s Idle: [%s]", nick->nick, convert_time(ltime));
		count++;
	}
}

void kickidle (char *command, char *args, char *subargs )
{
char *channel = NULL;
ChannelList *tmp;
int kick_count = 0;
int server;

	if (args && *args)
		channel = next_arg(args, &args);

	if ((tmp = prepare_command(&server, channel, NEED_OP)) && tmp->max_idle)
	{
		NickList *nick;
		for (nick = tmp->nicks; nick; nick = nick->next)
		{
			if (!my_stricmp(nick->nick, get_server_nickname(from_server)))
				continue;
			if (nick->userlist && check_channel_match(nick->userlist->channels, tmp->channel))
				continue;			
			if (nick->botlist && check_channel_match(nick->botlist->channels, tmp->channel))
				continue;
			if (time(NULL) - nick->idle_time >= tmp->max_idle)
			{
				if (kick_count <= get_int_var(MAX_IDLEKICKS_VAR))
					send_to_server("KICK %s %s :\002%s\002: (Idle Channel User)", tmp->channel, nick->nick, version);
				else
					bitchsay(" found idle user %-12s channel %s", nick->nick, tmp->channel);
				kick_count++;
			}
		}
	} else
		userage("KickIdle", "<channel>");
}

void save_idle(FILE *output)
{
ChannelList *chan;
int count = 0;
	if (!output)
		return;
	if (idlechan_list)
	{
		fprintf(output, "# %s Idle Channel list\n", version);
		for (chan = idlechan_list; chan; chan = chan->next)
		{
			if (chan->max_idle)
			{
				fprintf(output, "ADDIDLE %s %d\n", chan->channel, (int)chan->max_idle); 
				count++;
			}
		}
	}
	if (do_hook(SAVEFILE_LIST, "Idle %d", count))
		bitchsay("Saved %d Idle channels", count);
}

void channel_stats(char *command, char *args, char * subargs)
{
ChannelList *new = NULL;
char *channel = NULL;
WhowasChanList *new1 = NULL;
int numircops = 0;
int usershere = 0;
int usersaway = 0;
int chanops = 0;
int chanunop = 0;
char *ircops = NULL;
int server;

NickList *l; long nick_mem = 0, ban_mem = 0; BanList *b;

	if (args && *args)
		channel = next_arg(args, &args);
	if (!(new = prepare_command(&server, channel, NO_OP)) || (channel && !(new1 = check_whowas_chan_buffer(channel, 0))))
		return;

#if 0
	if (my_strnicmp(channel, "-A", 2)==0)
	{
	
	int stats_ops= 0, stats_dops = 0, stats_bans = 0, stats_unbans = 0;
	int stats_topics = 0, stats_kicks = 0, stats_pubs = 0, stats_parts = 0;
	int stats_signoffs = 0, stats_joins = 0;
	int total_nicks = 0, max_nicks = 0, total_bans = 0, max_bans = 0;
	int stats_sops = 0, stats_sdops = 0, stats_sbans = 0, stats_sunbans = 0;	
		
	NickList *l; 
	BanList *b;
	long nick_mem = 0, chan_mem = 0, ban_mem = 0;
	
		for (tmp = statchan_list; tmp; tmp = tmp->next)
		{

	if (from_server >= 0)
	{
		for (new = server_list[from_server].chan_list; new; new = new->next)
		{		
			for (l = new->nicks; l; l = l->next)
				nick_mem += sizeof(NickList);
			for (b = new->bans; b; b = b->next)
				ban_mem += sizeof(BanList);
			put_it("  MEM usage: Total: %ld bytes   [Nicks %ld b Chan %ld b Bans %ld b]", nick_mem+sizeof(ChannelList)+ban_mem, nick_mem, sizeof(ChannelList), ban_mem);
		}
	}
			chan_mem += sizeof(ChannelList);
			stats_ops += tmp->stats_ops;
			stats_dops += tmp->stats_dops;
			stats_bans += tmp->stats_bans;
			stats_unbans += tmp->stats_unbans;
			stats_topics += tmp->stats_topics;
			stats_kicks += tmp->stats_kicks;
			stats_pubs += tmp->stats_pubs;
			stats_parts += tmp->stats_parts;
			stats_signoffs += tmp->stats_signoffs;
			stats_joins += tmp->stats_joins;

			total_nicks += tmp->totalnicks;
			max_nicks += tmp->maxnicks;
			total_bans += tmp->totalbans;
			max_bans += tmp->maxbans;
			stats_sops += tmp->stats_sops;
			stats_sdops += tmp->stats_sdops;
			stats_sbans += tmp->stats_sbans;
			stats_sunbans += tmp->stats_sunbans;						
		}
		bitchsay("Stats for all channels since %s", my_ctime(start_time));
		put_it("  Time connected %s", convert_time(time(NULL)-start_time));
		put_it("  MEM Usage: Total: %ld bytes   [Nicks %ld b Chan %ld b Bans %ld b]", nick_mem+chan_mem+ban_mem, nick_mem, chan_mem, ban_mem);
		put_it("I've seen - ");
		put_it("   %03d - ops       %03d - de-ops    %03d - bans     %03d - unbans ",stats_ops, stats_dops, stats_bans, stats_unbans);
		put_it("   %03d - topics    %03d - kicks     %03d - publics  %03d - parts", stats_topics, stats_kicks, stats_pubs, stats_parts);
		put_it("   %03d - signoffs  %03d - joins", stats_signoffs, stats_joins);
		put_it("   %03d - serv ops  %03d - serv deop %03d - serv ban %03d - serv unban", stats_sops, stats_sdops,stats_sbans, stats_sunbans);
		put_it("   %03d - total nicks  %03d - max nicks", total_nicks, max_nicks);
		put_it("   %03d - max bans     %03d - total bans", max_bans, total_bans);
		bitchsay("End of All channel stats");
		return;		
	}
#endif
	if (!new && new1)
		new = new1->channellist;
		
	if (new)
	{
		for (l = new->nicks; l; l = l->next)
		{
			nick_mem += sizeof(NickList);
			switch(l->away)
			{
				case 'H':
					usershere++;
					break;
				case 'G':
					usersaway++;
				default:
					break;
			}
			if (l->ircop)
			{
				numircops++;
				malloc_strcat(&ircops, " (");
				malloc_strcat(&ircops, l->nick);
				malloc_strcat(&ircops, ")");
			}
			if (l->chanop)
				chanops++;
			else
				chanunop++;					
		}
		for (b = new->bans; b; b = b->next)
			ban_mem += sizeof(BanList);
	}
	if (!ircops)
		malloc_strcat(&ircops, " ");
	if (do_hook(CHANNEL_STATS_LIST, "%s %s %s %ld %ld %ld %ld %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %s", 
		new->channel, my_ctime(new->channel_create.tv_sec), convert_time(time(NULL)-new->channel_create.tv_sec),
		nick_mem+sizeof(ChannelList)+ban_mem, nick_mem, 
		sizeof(ChannelList),ban_mem, 
		new->stats_ops, new->stats_dops, new->stats_bans, new->stats_unbans,
		new->stats_ops, new->stats_dops, new->stats_bans, new->stats_unbans,
		new->stats_signoffs, new->stats_joins, new->totalbans, new->maxbans,
		new->stats_sops, new->stats_sdops,new->stats_sbans, new->stats_sunbans,
		usershere, usersaway, chanops, chanunop,new->totalnicks,new->maxnicks,
		numircops, ircops))
	{
		bitchsay("Information for channel : %s from %s", new->channel, my_ctime(new->channel_create.tv_sec)); 
		bitchsay("Channel created : %s", convert_time(time(NULL)-new->channel_create.tv_sec));
		put_it("     MEM usage: Total: %ld bytes   [Nicks %ld b Chan %ld b Bans %ld b]", nick_mem+sizeof(ChannelList)+ban_mem, nick_mem, sizeof(ChannelList), ban_mem);
		put_it("Ops        : %03d  De-Ops     : %03d  Bans       : %03d  Unbans     : %03d",new->stats_ops, new->stats_dops, new->stats_bans, new->stats_unbans);
		put_it("Topics     : %03d  Kicks      : %03d  Publics    : %03d  Parts      : %03d", new->stats_topics, new->stats_kicks, new->stats_pubs, new->stats_parts);
		put_it("Signoffs   : %03d  Joins      : %03d  TotalBans  : %03d  MaxBans    : %03d", new->stats_signoffs, new->stats_joins, new->totalbans, new->maxbans);
		put_it("ServOps    : %03d  ServDeop   : %03d  ServBans   : %03d  ServUB     : %03d", new->stats_sops, new->stats_sdops,new->stats_sbans, new->stats_sunbans);
		put_it("Users Here : %03d  Users Away : %03d  Opped      : %03d  Unopped    : %03d" ,usershere, usersaway, chanops, chanunop);
		put_it("TotalNicks : %03d  MaxNicks   : %03d", new->totalnicks,new->maxnicks);
		put_it("IRCops     : %03d%s", numircops, ircops); 

		put_it("  There is %s limit and limit checking is %s", new->limit ? ltoa(new->limit): "no", new->tog_limit?"Enabled":"Disabled");
		put_it("  I %s scanning and idle checking is %s", new->do_scan? "am":"am not",new->check_idle?"Enabled":"Disabled");
		bitchsay("End of channel stats for %s", new->channel);
	}
	new_free(&ircops);

}

void update_stats(int what, char *channel, char *who, ChannelList *chan, int splitter)
{
NickList *nick = NULL;
time_t this_time = time(NULL);
int t = 0;

	if (!chan || !who || !*who)
		return;
	
	if (!splitter)
		nick = (NickList *)find_in_list((List **)&chan->nicks, who, 0);

	switch (what)
	{
		case KICKLIST:
		{
			chan->stats_kicks++;
			chan->totalnicks--;
			if (nick) nick->stat_kicks++;
			break;
		}

		case LEAVELIST:
		{
			chan->stats_parts++;
			chan->totalnicks--;
			break;
		}
		case JOINLIST:
		{
			chan->stats_joins++;
			chan->totalnicks++;
			if (chan->totalnicks > chan->maxnicks)
			{
				chan->maxnicks = chan->totalnicks;
				chan->maxnickstime = this_time;
			}
			if (nick)
			{
				nick->joincount++;
				if (chan && my_stricmp(who, get_server_nickname(from_server)) &&
					chan->chop && (t = is_other_flood(chan, nick, DEOP_FLOOD)))
				{
					if (chan->set_joinflood && chan->set_kick_on_joinflood)
						send_to_server("KICK %s %s :\002Join flud. (%d in %dsecs)", channel, who, chan->set_kick_on_joinflood, t); 
				} 
			}
			break;
		}
		case CHANNELSIGNOFFLIST:
		{
			chan->stats_signoffs++;
			chan->totalnicks--;
			break;
		}
		case PUBLICLIST:
		case PUBLICOTHERLIST:
		case PUBLICNOTICELIST:
		case NOTICELIST:
		{
			chan->stats_pubs++;
			if (nick) nick->stat_pub++;
			break;
		}
		case TOPICLIST:
		{
			chan->stats_topics++;
			break; 
		}
		case MODEOPLIST:
			if (splitter)
				chan->stats_sops++;
			else
			{
				if (nick) nick->stat_ops++;		
				chan->stats_ops++;
			}
			break;
		case MODEDEOPLIST:
			if (splitter)
				chan->stats_sdops++;
			else
			{
				chan->stats_dops++;		
				if (nick) nick->stat_dops++;
			}

			if (chan && nick)
			{
				if (my_stricmp(who, get_server_nickname(from_server)) && 
					chan->chop && (t = is_other_flood(chan, nick, DEOP_FLOOD)))
				{
					if (chan->set_deop_on_deopflood < chan->set_kick_on_deopflood)
						send_to_server("MODE %s -o %s", channel, who);
					else
						send_to_server("KICK %s %s :\002De-op flud. (%d in %dsecs)", channel, who, chan->set_kick_on_deopflood, chan->set_kickflood_time); 
				} 
			}

			break;
		case MODEBANLIST:
			if (splitter)
				chan->stats_sbans++;
			else
			{
				if (nick) nick->stat_bans++;		
				chan->stats_bans++;
			}
			chan->totalbans++;
			if (chan->stats_bans > chan->maxbans)
			{
				chan->maxbans = chan->stats_bans;
				chan->maxbanstime = this_time;
			}
			break;
		case MODEUNBANLIST:
			if (splitter)
				chan->stats_sunbans++;
			else
			{
				if (nick) nick->stat_unbans++;
				chan->stats_unbans++;
			}
			if (chan->totalbans) chan->totalbans--;
			break;
		default:
			bitchsay("Illegal what %d passed to update_stats", what);
			break;
	}
}

void usage _((char *command, char *args, char *subargs))
{
#if !defined(sparc) && !defined(__sparc__) && !defined(HPUX) && !defined(_HPUX_SOURCE)
struct rusage r_usage;
	if ((0 == getrusage(RUSAGE_SELF, &r_usage)))
	{
		/* struct timeval ru_utime; user time used 
                 * struct timeval ru_stime;  system time used 
		 */                
		int secs = r_usage.ru_utime.tv_sec + r_usage.ru_stime.tv_sec;
		if (secs == 0)
			secs =1;
		
#ifdef WANT_ANSI
put_it("%s", convert_output_format("%G%WBitchX%G%WUsage%G%WStatistics%G%g---%G%g--%G%g-%G%g---%K%g--%K%g-%K", NULL));
put_it("%s",convert_output_format("%G| %CCPU %cUsage:  Secs %W$[-2]0%n:%W$[-2]1%n     %K[%CU%cser %W$[-2]2%n:%W$[-2]3   %CS%cystem %W$[-2]4%n:%W$[-2]5%K]","%d %d %d %d %d %d", secs/60,secs%60,r_usage.ru_utime.tv_sec/60, r_usage.ru_utime.tv_sec%60,r_usage.ru_stime.tv_sec/60, r_usage.ru_stime.tv_sec%60));
put_it("%s",convert_output_format("%g %CMEM %cUsage:  MaXRSS %W$0   %cShMem %W$1  %cData %W$2  %cStack %W$3","%l %l %l %l", r_usage.ru_maxrss, r_usage.ru_ixrss, r_usage.ru_idrss,r_usage.ru_isrss));
put_it("%s",convert_output_format("%g| %CSwaps %W$[-8]0   %CReclaims %W$[-8]1   %CFaults %W$[-8]2","%l %l %l", r_usage.ru_nswap, r_usage.ru_minflt, r_usage.ru_majflt));
put_it("%s",convert_output_format("%K %CBlock %K[%cin  %W$[-8]0  %cout %W$[-8]1%K]","%l %l", r_usage.ru_inblock, r_usage.ru_oublock));
put_it("%s",convert_output_format("%K: %CMsg   %K[%cRcv %W$[-8]0 %cSend %W$[-8]1%K]","%l %l", r_usage.ru_msgrcv, r_usage.ru_msgsnd));
put_it("%s",convert_output_format("%K. %CSignals %W$[-8]0   %CContext %cVol. %W$[-8]1   %cInvol %W$[-8]2","%l %l %l", r_usage.ru_nsignals, r_usage.ru_nvcsw, r_usage.ru_nivcsw));
#else
		bitchsay("CPU Usage:  Secs %d:%d     [User %d:%d   System %d:%d]",secs/60,secs%60,r_usage.ru_utime.tv_sec/60, r_usage.ru_utime.tv_sec%60,r_usage.ru_stime.tv_sec/60, r_usage.ru_stime.tv_sec%60);
		bitchsay("MEM Usage:  MaXRSS %ld   ShMem %ld  Data %ld  Stack %ld",r_usage.ru_maxrss, r_usage.ru_ixrss, r_usage.ru_idrss,r_usage.ru_isrss);
		bitchsay("Swaps %ld   Reclaims %ld   Faults %ld",r_usage.ru_nswap, r_usage.ru_minflt, r_usage.ru_majflt);
		bitchsay("Block [in  %ld    out  %ld]",r_usage.ru_inblock, r_usage.ru_oublock);
		bitchsay("Msg [Rcv %ld    Send %ld]",r_usage.ru_msgrcv, r_usage.ru_msgsnd);
		bitchsay("Signals %ld   Context Vol. %ld   Invol %ld",r_usage.ru_nsignals, r_usage.ru_nvcsw, r_usage.ru_nivcsw);
#endif
	}
#else
	bitchsay("This function needed to be disabled on your client");
#endif
}

void add_env _((char * args))
{
char *com;
	if ((com = next_arg(args, &args)))
	{
		if (!my_stricmp(com, "AWAYMSG"))
		{
			if (from_server >=0)
				malloc_strcpy(&awaymsg, args);
		}
		else
			bitchsay("Unknown ENV var");
	}
	else
		userage("env", "AWAYMSG <args>");
}


char *host_match = NULL;
char *user_hostserv = NULL;
int stats_k_found = 0;

void stat_k_userhost(WhoisStuff *stuff, char *nick, char *args)
{
char *user;
	if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
	{
		say("No match for user %s", nick);
		new_free(&user_hostserv);
		return;
	}
	user = stuff->user;
	if (*user == '~') user++;
	if (*user == '#') user++;
	malloc_sprintf(&host_match, "*!%s@%s", user, stuff->host);
	send_to_server("STATS K %s", user_hostserv?user_hostserv : "");
	new_free(&user_hostserv);
}

void statkgrep(char *command, char *args, char *subargs)
{
char *person;
	if (args && *args)
	{
		person = next_arg(args, &args);
		if (person && *person)
		{
			stats_k_found = 0;
			if (strchr(person, '!') && strchr(person, '@'))
				malloc_strcpy(&host_match, person);
			else if (strchr(person, '@'))
				malloc_sprintf(&host_match, "*!%s", person);
			else if (strchr(person, '!'))
				malloc_sprintf(&host_match, "%s@*", person);
			else
			{
				if (args && *args)
					malloc_strcpy(&user_hostserv, args);
				add_to_userhost_queue(person, stat_k_userhost, person);
				return;
			}
			send_to_server("STATS K %s", args && *args ? args : "");
		}		
	}
	else
		userage("FkLine","<nick\002|\002user@hostname> [servername]");
}

int stats_k_grep(char **args)
{
/*
 * arg[1] has the banned host
 * arg[3] has the username.
 */
char *user, *host, *p;
char *nick1, *user1, *host1;
char *tmp1 = NULL;

	/* if host_match is null just return, as we are not doing a grep */
	user = args[3];
	host = args[1];
	if (!host_match || !args || !host || !*host || !user || !*user)
		return 0;

	/* break up host_match into various parts. */
	malloc_strcpy(&tmp1, host_match);
	nick1 = tmp1;
	if ((p = strchr(nick1, '!')))
		*p = '\0';
	user1 = ++p;
	if ((p = strchr(user1, '@')))
		*p = '\0';
	host1 = ++p;
		
	if (!strcmp(host, "*") || match(host1, host) || match(host, host1))
		if (!strcmp(user, "*") || match(user1, user) || match(user, user1))
		{
			bitchsay("SBan match  %s!%s : %s", user,host,args[2]?args[2]:"none");
			stats_k_found++;
		}
	new_free(&tmp1);
	return 1;
}

void stats_k_grep_end(void)
{
	if (stats_k_found && host_match)
		bitchsay("Found %d matching %s server ban%s", stats_k_found, host_match, plural(stats_k_found));
	else if (host_match)
	{
		bitchsay("No Server bans matching [%s].", host_match);
		new_free(&host_match);
		stats_k_found = 0;
	}
	return;
}

/* Borrowed with permission from FLiER */
char *stripansicodes(char *line)
{
register char *tstr;
register char *nstr;
int  gotansi=0;
static char newline[6*BIG_BUFFER_SIZE+1];

/*	memset(newline, 0, sizeof(newline));*/
	tstr=line;
	nstr=newline;
	while (*tstr) 
	{
		if (*tstr==0x1B) 
			gotansi=1;
		if (gotansi && isalpha(*tstr)) 
			gotansi = 0;
		else if (!gotansi) 
		{
			*nstr = *tstr;
			nstr++;
		}
		tstr++;
	}
	*nstr = 0;
	return newline;
}

int check_split(char *nick, char *reason, char *chan)
{
char *bogus = get_string_var(FAKE_SPLIT_PATS_VAR);
	if (match("%.% %.%", reason) && !strstr(reason, "))") )
	{
		if (bogus)
		{
			char *copy = NULL;
			int fake = 0;
			char *b_check;
			char *temp;
			malloc_strcpy(&copy, bogus);
			temp = copy;
			while((b_check = next_arg(copy, &copy)))
			{
				if ((fake = match(b_check, reason)))
					break;
			}
			new_free(&temp);
			return fake ? 0:1;
		}
		return 1;
	} else 
		return 0;
}

void clear_array(NickTab **tmp)
{
NickTab *t, *q;
	for (t = *tmp; t; )
	{
		q = t->next;
		new_free(&t->nick);
		new_free((char **)&t);
		t = q;
	}
	*tmp = NULL;
}

void clear_tab (char *command, char *args, char *subargs)
{
NickTab **tmp = &tabkey_array;
	if (command && *command && !my_stricmp(command, "CLEARAUTO"))
		tmp = &autoreply_array;		
	clear_array(tmp);
}

/* 
 * set which to 1 to access autoreply array.
 * 0 for msglist array
 */

void addtabkey(char *nick, int which)
{
NickTab *tmp, *new;
	if (which == 1)
		tmp = autoreply_array;
	else
		tmp = tabkey_array;	
	if (!tmp || !(new = (NickTab *)remove_from_list((List **)&tmp, nick)))
	{
		new = (NickTab *)new_malloc(sizeof(NickTab));
		malloc_strcpy(&new->nick, nick);
	}
	/*
	 * most recent nick is at the top of the list 
	 */
	new->next = tmp;
	tmp = new;
	if (which == 1)
		autoreply_array = tmp;
	else
		tabkey_array = tmp;	
}

char *gettabkey(int direction, int which)
{
NickTab *tmp, *new;

	if (which == 1)
		tmp = new = autoreply_array;
	else
		tmp = new = tabkey_array;

	if (!tmp)
		return NULL;
		
	switch(direction)
	{
		case 1:
		default:
		{
			/*
			 * need at least two nicks in the list
			 */
			if (new->next)
			{
				/*
				 * reset top of array
				 */
				if (which == 1)
					autoreply_array = new->next;
				else
					tabkey_array = new->next;
				
				/*
				 * set the current nick next pointer to NULL
				 * and then reset top of list.
				 */
				
				new->next = NULL;
				if (which == 1)
					tmp = autoreply_array;
				else
					tmp = tabkey_array;
				
				/*
				 * find the last nick in the list
				 * so we can make the old top pointer 
				 * point to the item
				 */
				while (tmp)
					if (tmp->next)
						tmp = tmp->next;
					else
						break;
				/* set the pointer and then return. */
				tmp->next = new;		
			}
			break;
		}
		case -1:
		{
			if (new && new->next)
			{
				tmp = new;
				while(tmp)
					if (tmp->next && tmp->next->next)
						tmp = tmp->next;
					else
						break;
				/* 
				 * tmp now points at last two items in list 
				 * now just swap some pointers.
				 */	
				new = tmp->next;
				tmp->next = NULL;
				if (which == 1)
				{
					new->next = autoreply_array;
					autoreply_array = new;
				} else {
					new->next = tabkey_array;
					tabkey_array = new;
				}
			}
			break;
		}
	}
	if (new && new->nick)
		return new->nick;
	return NULL;
}

void userage(char *command, char *use)
{
	if (do_hook(USAGE_LIST, "%s %s", command, use))
#ifdef WANT_ANSI
put_it("%s", convert_output_format(get_string_var(FORMAT_USAGE_VAR), "%s %s", command, use));
#else
		bitchsay("Usage: %s %s", command, use);
#endif
}

char *random_str(int min, int max)
{
	int i, ii;
	static char str[BIG_BUFFER_SIZE+1];

	i = getrandom(min, max);
	for (ii = 0; ii < i; ii++)
		str[ii] = (char) getrandom(97, 122);
	str[ii] = '\0';
	return str;
}

void do_clones (fd_set *rd, fd_set *wr)
{
CloneList *new = NULL;
	for (new = clones; new; new = new->next)
	{
		if (!new->warn && FD_ISSET(new->socket_num, rd))
		{
			int old_timeout = dgets_timeout(1);
			char buffer[BIG_BUFFER_SIZE + 1];
			char *str = buffer;
			switch(dgets(str, BIG_BUFFER_SIZE-2, new->socket_num, NULL))
			{
				case -1:
					break;
				case 0:
					break;
				default:
				if ((buffer[strlen(buffer)-1] == '
') || (buffer[strlen(buffer)-1] == '\r') || (buffer[strlen(buffer)-1] == '\n'))
					buffer[strlen(buffer)-1] = 0;
				if ((buffer[strlen(buffer)-1] == '
') || (buffer[strlen(buffer)-1] == '\r') || (buffer[strlen(buffer)-1] == '\n'))
					buffer[strlen(buffer)-1] = 0;
				do_hook(CLONE_READ_LIST, "%d %d %s %s", new->socket_num, new->port, new->server, buffer);
			}
			dgets_timeout(old_timeout);
		}
	}
}

void auto_away(unsigned long value)
{
extern void away _((char *, char *, char *));
	if (get_int_var(AUTO_AWAY_VAR) && !away_set)
	{
		char *msg = NULL;
		if (awaymsg)
			malloc_sprintf(&msg, "%s: [%d mins]", convert_output_format(awaymsg, NULL), get_int_var(AUTO_AWAY_TIME_VAR)/60);
		else
			malloc_sprintf(&msg, "Auto-Away after %d mins", get_int_var(AUTO_AWAY_TIME_VAR)/60);
		away(NULL, msg, NULL);
		new_free(&msg);		
	}
}

char *logfile[] = { "tcl.log", "msg.log", NULL };

/* putlog(level,channel_name,format,...);  */
void putlog(int type, ...)
{
va_list va; 
char	*format,
	*chname,
	*logfilen = NULL, 
	s[BIG_BUFFER_SIZE+1],
	s1[40],
	s2[BIG_BUFFER_SIZE+1];
FILE	*f; 
	if (!get_int_var(BOT_LOG_VAR))
		return;
	if (!(logfilen = get_string_var(BOT_LOGFILE_VAR)))
		return;
			
	va_start(va, type); 
	
	chname=va_arg(va,char *);
	format=va_arg(va,char *);
	vsprintf(s,format,va);
	
	if (!*s) 
		strcpy(s,"");
	else 
	{
		strcpy(s1,my_ctime(time(NULL))); 
		strcpy(s1,&s1[11]); 
		s1[5]=0;
		sprintf(s2,"[%s] %s",s1,s); 
		strcpy(s,s2);
	}

	if ((chname[0]=='*'))
/*		|| (logchan[i][0]=='*') || (!my_stricmp(chname,logchan[i]))*/
	{
		if ((f=fopen(logfilen, "a+")) != NULL)
		{
			fprintf(f,"%s\n",s); 
			fclose(f);
		}
	}
}

int rename_file (char *old_file, char **new_file)
{
	char *tmp = NULL, *new_f = NULL;
	char c = '_';
	FILE *fp;
			
	if (get_string_var(DCC_DLDIR_VAR))
		malloc_sprintf(&tmp, "%s/%%c%s", get_string_var(DCC_DLDIR_VAR), *new_file);
	else
		malloc_sprintf(&tmp, "%%c%s",*new_file); 
	malloc_sprintf(&new_f, tmp, c);
	while ((fp = fopen(new_f, "r")) != NULL)
	{
		fclose(fp);
		c++;
		sprintf(new_f, tmp, c);
	}
	fclose(fp);
	new_free(&tmp);
	new_free(&new_f);
	malloc_sprintf(new_file, "%c%s", c, *new_file);
	return 0;
}

ChannelList *prepare_command(int *active_server, char *channel, int need_op)
{
int server = 0;
ChannelList *chan = NULL;
	if (!channel && !get_channel_by_refnum(0)) 
	{
		if (need_op != 3) 
			not_on_a_channel(curr_scr_win);
		return NULL;
	}
	server = curr_scr_win->server;
	*active_server = server;
	if (!(chan = lookup_channel(!channel? get_channel_by_refnum(0):channel, server, 0)))
	{
		if (need_op != 3) 
			not_on_a_channel(curr_scr_win);
		return NULL;
	}
	if (need_op == NEED_OP && chan && !chan->chop) 
	{
		error_not_opped(chan->channel);
		return NULL;
	}
	return chan;
}

